<?php
/*

Google Map API for PmWiki
=========================

Copyright Statement
-------------------

Copyright (c) 2006, Benjamin C. Wilson. All Rights Reserved. You have
permission to use this software for web site use provided this copyright
statement remains intact. You may not otherwise republish or alter this software
without prior permission of the author. License to publish granted
PmWiki.org for distribution to the PmWiki community. This copyright
statement must accompany the script.

You may contact the author at ameen@dausha.net. This software is
maintained at http://www.dausha.net/GoogleMapAPI/.

Notice:
-------

This is a class definition file belonging to a larger program.

*/

$GmaIconPopulation = 0;
class GmaIcon
{
  var $population = '';
  var $_path = 'http://www.google.com/mapfiles/';
  var $pal = 2;
  var $inum = -1;
  var $mletter = '';
  function GmaIcon() {
    global $GmaIconPopulation;
    $this->id = $GmaIconPopulation++;
    $this->letter = '';
    # http://www.econym.demon.co.uk/googlemaps/geicons.htm
    # http://www.mapki.com/wiki/Available_Images
  }
  function getMarkerIcon() {
    $path = $this->_path . 'marker' . strtoupper($this->mletter) . '.png';
    return $path;
  }
  function getStdIcon() {
     $inum = $this->inum;
     $pal = $this->pal;
     $pal = ($pal < 2) ? 2 : ($pal > 5) ? 5 : $pal;
     $inum = ($inum < 0) ? 0 : ($inum > 63) ? 63 : $inum;
     return array(
        "http://www.google.com/mapfiles/kml/pal{$pal}/icon{$inum}.png",
        "http://www.google.com/mapfiles/kml/pal{$pal}/icon{$inum}s.png"
     );
  }
  function getMiniIcon () {
     $mm = strtolower($this->mm);
     $colors = array(
       'purple' => 1, 'yellow' => 1, 'blue' => 1, 'white' => 1,
       'green' => 1, 'red' => 1, 'black' => 1, 'orange' => 1,
       'gray' => 1, 'brown' => 1
     );
     $color = (array_key_exists($mm, $colors)) ? $mm : 'red';
     return "http://labs.google.com/ridefinder/images/mm_20_{$color}.png";
  }
  function getID() {
    return 'icon'.$this->id;
  }
  function size() {
    list($h, $w) = split(',', $this->size);
  }
  function icon() {
    $id = $this->getID();

    if ($this->mm) {
      $type = 'miniIcon';
      $img = $this->getMiniIcon();
      $simg = 'http://labs.google.com/ridefinder/images/mm_20_shadow.png';
    }
    elseif ($this->inum != -1) {
      $type = 'stdIcon';
      list($img, $simg) = $this->getStdIcon();
    }
    else {
      $type = 'markerIcon';
      $img = $this->getMarkerIcon();
    }
    $out = "      var $id = new GIcon($type);\n";
    if ($simg) $out .= "      $id.shadow = '$simg';\n";
    $out .= "      $id.image = '$img';\n";

    $out .="\n";

    return $out;
  }
} // End Class GmaIcon
