<?php
/*

Google Map API for PmWiki
=========================

Copyright Statement
-------------------

Copyright (c) 2006, Benjamin C. Wilson. All Rights Reserved. You have
permission to use this software for web site use provided this copyright
statement remains intact. You may not otherwise republish or alter this software
without prior permission of the author. License to publish granted
PmWiki.org for distribution to the PmWiki community. This copyright
statement must accompany the script.

You may contact the author at ameen@dausha.net. This software is
maintained at http://www.dausha.net/GoogleMapAPI/.
*/

$GmaPolylinePopulation = 0;
class GmaPolyline
{
  function GmaPolyline() {
    global $GmaPolylinePopulation;
    global $GmapPLColor, $GmapPLThick, $GmapPLOpacy;
    $this->color = $GmapPLColor;
    $this->id = $GmaPolylinePopulation++;
    $this->opacity = $GmapPLOpacy;
    $this->points = array();
    $this->thickness = $GmapPLThick;
    return $this;
  }

  function addPoint($lat, $lon) {
    $point = "new GLatLng($lat,$lon)";
    if ($lat) $this->lat = $lat;
    if ($lon) $this->lon = $lon;
    if ($lat && $lon) array_push($this->points, $point);
  }

  function getID() { return 'polyline'.$this->id; }

  function overlay() {
    $id = $this->getID();
	return "      map.addOverlay($id);\n";
  }

  function color() {
    // This method returns only web-safe colors.
    $out = '';
    $color = $this->color;
    $color = preg_replace("/\\\'/",'',$color);

    if (0 === strpos($color, '#')) $color = substr($color, 1);

    // break into hex 3-tuple
    $cutpoint = ceil(strlen($color) / 2) - 1;
    $rgb = explode(':', wordwrap($color, $cutpoint, ':', $cutpoint), 3);

    foreach($rgb as $r) {
        if (strlen($r) == 1) $r .= $r; # Expand single value colors.
        $r = (isset($r)) ? hexdec($r) : 0; # Hex to Dec.
        $r = (round($r/51) * 51); # Make web-safe
        $out .= str_pad(dechex($r), 2, '0', STR_PAD_LEFT); # Code color.
    }
    return "'#$out'";
  }
  function polyline() {
    $id = $this->getID();
    $pad = str_pad('', 28 + strlen($id), ' ', STR_PAD_LEFT);
    $points = '['.join(",\n$pad", $this->points).']';
    $options = join(', ', 
                array(
                    $points, 
                    $this->color(), 
                    $this->thickness, 
                    $this->opacity)
                );
    return "      var $id = new GPolyline($options);\n";
  }

} // End Class GmaPolyline
